#include "getFileInfo.h"
#include "globalVariable.h"
using namespace std;

getFileInfo::getFileInfo()
{

}

int getFileInfo::saveToLink(struct fileInfoNode*& head, const string& fileName, const struct _finddata64i32_t& fileInfo) 
{
	 fileInfoNode* p;
	 p=new fileInfoNode;
	 p->fileInfo=fileInfo;  
	 p->fileName=fileName;
	 p->left=head;
	 head=p;
	 return 0;
}

void getFileInfo::displayLink(struct fileInfoNode* head)
{
	while(head!=NULL)
	{
		allFileInfo[filenum].fileName = head->fileName;
		allFileInfo[filenum].fileInfo = head->fileInfo;
		filenum++;
		head=head->left;
	}
}

void getFileInfo::saveLinkToFile(struct fileInfoNode* head,string saveFileName,int counter)
{
	ofstream fout;

	fout.open(saveFileName.c_str());
	if((fout.is_open())==false)
	{
		cout<<"Fail to open file"<<endl;
		exit(-1);
	}

	fout<<"the file number is: "<<counter<<endl;
	fout<<"-------------------------------------------------------------------------------------------------------"<<endl;
	while(head!=NULL)
	{
		fout<<"fileName: "<<head->fileName<<endl;
		fout<<"fileSize: "<<dec<<head->fileInfo.size<<"ֽ"<<endl;
		fout<<"fileAttrib: "<<"0x"<<hex<<head->fileInfo.attrib<<endl;
		fout<<"-------------------------------------------------------------------------------------------------------"<<endl;
		head=head->left;
	}
	fout.close();
}


int getFileInfo::searchAllFile(string filePath,	int layer, string fileInfoOut)  
{
	struct _finddata64i32_t fileInfo;

	static fileInfoNode* head=NULL; 
	static int counter=0;  
	long handle;
	int done;
	string fileName=filePath+"\\*.*"; 

	handle=_findfirst64i32(fileName.c_str(),&fileInfo);
	if(handle==-1)
	{
		cout<<"Empty directory!"<<endl;
		//cin.get();
		 return -1;
	}
	do
	{
		if((strcmp(fileInfo.name,".")==0)|(strcmp(fileInfo.name,"..")==0))
		{
			continue;
		}
		if((fileInfo.attrib&_A_SUBDIR)==_A_SUBDIR)
		{
			string filePathSub=filePath+"\\"+fileInfo.name;
			searchAllFile(filePathSub,++layer,fileInfoOut);
			layer--;
		}
		else
		{
			counter++;
			string fileNameTure=filePath+"\\"+fileInfo.name;
			saveToLink(head,fileNameTure,fileInfo);   
		}

	}while(!(done=_findnext64i32(handle,&fileInfo)));
	_findclose(handle);
	if(layer==0)
	{
			displayLink(head);
	}
	return 0;

}