#include "globalVariable.h"
#include "md5.h"
#include "getFileInfo.h"
#include "fileBlock.h"

#include <time.h>
#include <iostream>
#include <string>
#include <sys/types.h>
#include <sys/stat.h>
#include <fstream>
using namespace std;
#include <windows.h>

typedef void (WINAPI *LPFN_PGNSI)(LPSYSTEM_INFO);

void outPut(int num,  string outPutFileName);
string getMd5(string filename);

void main()
{
	string filepath ="";
	string outPutFileName = "result-";
	char path[500];
	char username[500];
	char cloudname[500];
	int if64bit = 0;

	LPFN_PGNSI pGNSI = (LPFN_PGNSI) GetProcAddress(GetModuleHandle(TEXT("kernel32.dll")), "GetNativeSystemInfo");
	SYSTEM_INFO s;
	if(pGNSI != NULL)
		pGNSI(&s);
	else
		GetSystemInfo(&s);
	if64bit = s.wProcessorArchitecture;

	cout<<"Input the cloud storage (sync folder) directory path (e.g., d:\\Dropbox): "<<endl;
	gets(path);
	filepath += path;

	cout<<endl<<"Input the username (letters and/or numbers, e.g., lizhenhua1983): "<<endl;
	gets(username);
	outPutFileName += username;

	cout<<endl<<"Input the cloud storage service name (e.g., dropbox): "<<endl;
	gets(cloudname);
	outPutFileName += '-';
	outPutFileName += cloudname;
	outPutFileName += ".txt";

	getFileInfo fileinfo;
	fileinfo.searchAllFile(filepath,0,"D:\\1.txt");
	cout<<endl;
	cout<<"Total number of files under the directory: "<<dec<<filenum<<endl;

	struct tm *timeinfo;
	char tmpbuf1[1280];
	char tmpbuf2[1280];

	fileBlock fileblock;
	char compressBuff[1512];
	
	string compressFile = "";
	compressFile +="temp.rar";
	
	struct _stat buf;
	int result;
	long int copressFileSize=0;
	int ifrename = 0;
	int i;
	for(i=0; i<filenum; i++)
	{
		cout<<"*******************************************************************"<<endl;
		cout<<"Number of files processed: "<<i<<endl;
		cout<<"*******************************************************************"<<endl;
		cout<<endl<<endl;
		cout<<"Current file being processed: "<<allFileInfo[i].fileName<<endl;
		cout<<"-----------------------------------------------------"<<endl;
		for(int j=0; j<1000; j++)
			fileBasicInfo[j] = 0;

		for(int j=0; j<1512; j++)
			compressBuff[j] = 0;
		if(if64bit == 9)
			sprintf(compressBuff, "Rar64.exe a -m5 \"temp.rar\" \"%s\"", allFileInfo[i].fileName.c_str()); 
		else
			sprintf(compressBuff, "Rar32.exe a -m5 \"temp.rar\" \"%s\"", allFileInfo[i].fileName.c_str()); 
		system(compressBuff);

		result = _stat(compressFile.c_str(), &buf); 
		if(result != 0)
		{
			perror("Unable to compress the file.");
			copressFileSize = 0;
			compresserrornum++;
		}
		else
		{
			copressFileSize = buf.st_size;
		}

		for(int j=0; j<1512; j++)
			compressBuff[j] = 0;
		sprintf(compressBuff, "del \"%s\"", compressFile.c_str());
		system(compressBuff);

		timeinfo = localtime(&allFileInfo[i].fileInfo.time_create); 
		strftime(tmpbuf1, 1280, "%Y-%m-%d-%H:%M:%S", timeinfo);
		timeinfo = localtime(&allFileInfo[i].fileInfo.time_write); 
		strftime(tmpbuf2, 1280, "%Y-%m-%d-%H:%M:%S", timeinfo);

		sprintf(fileBasicInfo, "%s\t%s\t%s\t%d\t%d\t%s\t%s\t", username, cloudname, getMd5(allFileInfo[i].fileName).c_str(), allFileInfo[i].fileInfo.size, 
			copressFileSize, tmpbuf1, tmpbuf2);

		fileblock.getFileMd5(allFileInfo[i].fileName);

		outPut(i, outPutFileName);
		cout<<endl;
		cout<<endl;
	}
	cout<<endl;
	cout<<"*******************************************************************"<<endl;
	cout<<"Finish all the processing works!"<<endl;
	cout<<"Total number of files processed: "<<filenum<<endl;
	cout<<"Number of files that cann't be processed: "<<errornum<<endl;
	cout<<"Number of files that cann't be compressed: "<<compresserrornum<<endl;
	cout<<"*******************************************************************"<<endl;
	cout<<endl;

	cout<<"Press any key to continue ...";
	getchar();
}

string getMd5(string filename)
{
	string returnstr = "";
	md5_state_t state;
	md5_byte_t digest[16];
	char hex_output[16*2 + 1];
	int di;

	md5_init(&state);
	md5_append(&state, (const md5_byte_t *)filename.c_str(), filename.length());
	md5_finish(&state, digest);
	for (di = 0; di < 16; ++di)
	    sprintf(hex_output + di * 2, "%02x", digest[di]);
	
	returnstr += hex_output;
	return returnstr;
}

void outPut(int num, string outPutFileName)
{
	FILE *fp;
	int j;
	if(num==0)
		fp = fopen(outPutFileName.c_str(), "w");
	else
		fp = fopen(outPutFileName.c_str(), "a");

	if(fp==NULL)
		cout<<"Fail to open the file"<<endl;

	for(j=0; j<1000; j++)
	{
		if(fileBasicInfo[j] == 0)
			break;
	}

	fwrite(fileBasicInfo, j, 1, fp);
	fwrite(fileMd5List.c_str(), fileMd5List.length(), 1, fp);
	fclose(fp);
}


